import request from '~/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { CmsMp, CmsMpParam } from './model';


/**
 * 分页查询小程序信息
 */
export async function pageCmsMp(params: CmsMpParam) {
  const res = await request.get<ApiResult<PageResult<CmsMp>>>(
    '/cms/cms-mp/page',
    {
      params
    }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询小程序信息列表
 */
export async function listCmsMp(params?: CmsMpParam) {
  const res = await request.get<ApiResult<CmsMp[]>>(
    '/cms/cms-mp',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加小程序信息
 */
export async function addCmsMp(data: CmsMp) {
  const res = await request.post<ApiResult<unknown>>(
    '/cms/cms-mp',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改小程序信息
 */
export async function updateCmsMp(data: CmsMp) {
  const res = await request.put<ApiResult<unknown>>(
    '/cms/cms-mp',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除小程序信息
 */
export async function removeCmsMp(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-mp/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除小程序信息
 */
export async function removeBatchCmsMp(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-mp/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询小程序信息
 */
export async function getCmsMp(id: number) {
  const res = await request.get<ApiResult<CmsMp>>(
    '/cms/cms-mp/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
